#include <ioavr.h>
#include <inavr.h>
#include "main.h"
#include "TWI_Master.h"
#include "main_m.h"

#include "all_prog.c" 

  uchar error_TWI = 0;
  volatile uchar input;

/*******************************************************************************
*******************************************************************************/
uchar TWI_Act_On_Failure_In_Last_Transmission ( uchar TWIerrorMsg )
{
    if ( (TWIerrorMsg == TWI_MTX_ADR_NACK) | (TWIerrorMsg == TWI_MRX_ADR_NACK) )
    {
      error_TWI++;
        if (error_TWI > 16)
        {
          TWI_statusReg.lastTransOK = TRUE;
          error_TWI = 0;
        }

        else
        {
          TWI_Start_Transceiver();
        }
    }         

    return TWIerrorMsg; 
}

/*******************************************************************************
*        MAIN                                                                  *
*******************************************************************************/
void main(void)
{
    TWI_Master_Initialise();
    __enable_interrupt();

    Init_Const();

    for(;;)
    {  
        switch ( command_twi ) 
        {
          case RD_TWI_SLAVE:
            message_buf[0] = (TWI_targetSlaveAddress | (FALSE<<TWI_READ_BIT));
            message_buf[1] = byte_addr_comm;
            TWI_Start_Transceiver_With_Data( message_buf, number_byte_wr_slave );
            TWI_operation = REQUEST_DATA_FROM_SLAVE;
            command_twi = NO_COMMAND;
          break;

          case WR_TWI_SLAVE:
            message_buf[0] = (TWI_targetSlaveAddress | (FALSE<<TWI_READ_BIT));
            message_buf[1] = byte_addr_comm;
            TWI_Start_Transceiver_With_Data( message_buf, number_byte_wr_slave );
            TWI_operation = END_WRITE_DATA;
            command_twi = NO_COMMAND;
          break;
        }

        if ( ! TWI_Transceiver_Busy() )
        {
            if ( TWI_statusReg.lastTransOK )
            {
                switch (TWI_operation)
                {
                  case REQUEST_DATA_FROM_SLAVE:
                    message_buf[0] = (TWI_targetSlaveAddress | (TRUE<<TWI_READ_BIT));
                    TWI_Start_Transceiver_With_Data( message_buf, number_byte_rd_slave );
                    TWI_operation = READ_DATA_FROM_BUFFER;
                  break;

                  case READ_DATA_FROM_BUFFER:
                    TWI_Get_Data_From_Transceiver( message_buf, number_byte_rd_slave );
                    TWI_operation = FALSE;
                  break;

                  case END_WRITE_DATA:
                    TWI_operation = FALSE;
                  break;

                  case FALSE:
                  break;

                  default:
	              break;
                }
            }            // if ( TWI_statusReg.lastTransOK )

            else
            {
              // TWI status information
              TWI_Act_On_Failure_In_Last_Transmission( TWI_Get_State_Info( ) );
            }
        }              // if ( ! TWI_Transceiver_Busy() )

          Vym();               // for U2

          Opto_Upr();          // for U3

    }
}
